<ui:composition
        xmlns:s="http://jboss.org/schema/seam/taglib"
        xmlns:f="http://java.sun.com/jsf/core"
        xmlns:rich="http://richfaces.org/rich"
        xmlns:h="http://java.sun.com/jsf/html"
        xmlns:g="http://www.ihe.net/gazelle"
        xmlns:ui="http://java.sun.com/jsf/facelets"
        xmlns:a4j="http://richfaces.org/a4j"
        xmlns="http://www.w3.org/1999/xhtml"
        template="//layout/template.xhtml">
    <ui:define name="body">
        <h1>#{messages['net.ihe.gazelle.simulators.SimulatorConsole']}</h1>
        <h:form id="globalform">
            <a4j:queue requestDelay="300" ignoreDupResponses="true"/>
            <h:inputHidden id="filterUrlParameters" name="filterUrlParameters"
                           value="#{consoleBrowser.filter.urlParameters}"/>
            <script>
                updateUrl("globalform:filterUrlParameters");
                jq162("#globalform\\:filterUrlParameters").bind('change',
                        function () {
                            updateUrl("globalform:filterUrlParameters");
                        });
            </script>
            <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">
                <ui:define name="panel_title">#{messages['gazelle.simu.SearchCriteria']}</ui:define>
                <div class="row">
                    <div class="col-md-4">
                        <ui:include src="/filter/filter.xhtml">
                            <ui:param name="filter" value="#{consoleBrowser.filter}"/>
                            <ui:param name="filterId" value="domain"/>
                            <ui:param name="filterName" value="#{messages['gazelle.simu.Domain']}"/>
                            <ui:param name="filterForm" value="globalform"/>
                        </ui:include>
                    </div>
                    <div class="col-md-4">
                        <ui:include src="/filter/filter.xhtml">
                            <ui:param name="filter" value="#{consoleBrowser.filter}"/>
                            <ui:param name="filterId" value="simulatedActor"/>
                            <ui:param name="filterName" value="#{messages['gazelle.simu.SimulatedActor']}"/>
                            <ui:param name="filterForm" value="globalform"/>
                        </ui:include>
                    </div>
                    <div class="col-md-4">
                        <ui:include src="/filter/filter.xhtml">
                            <ui:param name="filter" value="#{consoleBrowser.filter}"/>
                            <ui:param name="filterId" value="transaction"/>
                            <ui:param name="filterName" value="#{messages['gazelle.simu.Transaction']}"/>
                            <ui:param name="filterForm" value="globalform"/>
                        </ui:include>
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-4">
                        <ui:include src="/filter/filter.xhtml">
                            <ui:param name="filter" value="#{consoleBrowser.filter}"/>
                            <ui:param name="filterId" value="mtype"/>
                            <ui:param name="filterName" value="#{messages['net.ihe.gazelle.simulators.MessageType']}"/>
                            <ui:param name="filterForm" value="globalform"/>
                        </ui:include>
                    </div>
                    <div class="col-md-4">
                        <ui:include src="/filter/filter.xhtml">
                            <ui:param name="filter" value="#{consoleBrowser.filter}"/>
                            <ui:param name="filterId" value="sut"/>
                            <ui:param name="filterName" value="#{messages['net.ihe.gazelle.simulators.SystemUnderTest']}"/>
                            <ui:param name="filterForm" value="globalform"/>
                        </ui:include>
                    </div>
                    <div class="col-md-4">
                        <ui:include src="/filter/filter.xhtml">
                            <ui:param name="filter" value="#{consoleBrowser.filter}"/>
                            <ui:param name="filterId" value="code"/>
                            <ui:param name="filterName" value="#{messages['net.ihe.gazelle.simulators.AckCode']}"/>
                            <ui:param name="filterForm" value="globalform"/>
                        </ui:include>
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-6">
                        <ui:include src="/filter/filterDate.xhtml">
                            <ui:param name="filter" value="#{consoleBrowser.filter}"/>
                            <ui:param name="filterId" value="timestamp"/>
                            <ui:param name="filterName" value="#{messages['gazelle.simu.Timestamp']}"/>
                            <ui:param name="filterForm" value="globalform"/>
                        </ui:include>
                    </div>
                </div>
                <ui:define name="filter_buttons">
                    <a4j:commandLink title="#{messages['net.ihe.gazelle.simulators.RefreshResults']}"
                                     render="globalform">
                        <span class="gzl-icon-refresh"/>
                    </a4j:commandLink>
                    <a4j:commandLink title="#{messages['net.ihe.gazelle.simulators.Reset']}"
                                     actionListener="#{consoleBrowser.reset()}"
                                     render="globalform">
                        <span class="fa fa-times-circle"></span>
                    </a4j:commandLink>
                </ui:define>
            </ui:decorate>
            <ui:decorate template="/layout/panels/_panel_title.xhtml">
                <ui:define name="panel_title">#{messages['gazelle.simu.Messages']}</ui:define>
                #{dataTableStateHolder.setDescendingOn('timestamp')}
                <rich:dataTable value="#{consoleBrowser.getLogs()}"
                                var="log" rows="#{dataScrollerMemory.numberOfResultsPerPage}" id="messageList"
                                render="ds">
                    <g:column
                            sortBy="#{'timestamp'}"
                            sortOrder="#{dataTableStateHolder.sortOrders['timestamp']}">
                        <ui:define name="header">#{messages['gazelle.simu.Timestamp']}
                        </ui:define>
                        <g:date value="#{log.timestamp}"/>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['gazelle.simu.Domain']}</ui:define>
                        <h:outputText
                                value="#{log.domain.keyword}"/>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['gazelle.simu.SimulatedActor_2']}</ui:define>
                        <h:outputText
                                value="#{log.simulatedActor.name}"/>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['gazelle.simu.Transaction']}</ui:define>
                        <h:outputText value="#{log.transaction.keyword}"/>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['net.ihe.gazelle.simulators.SUT']}</ui:define>
                        <h:outputText
                                value="#{log.sut}"/>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['net.ihe.gazelle.simulators.MessageType']}</ui:define>
                        <h:outputText
                                value="#{log.messageType}"/>
                    </g:column>
                    <g:column filterBy="#{'messageIdentifier'}" filterEvent="keyup">
                        <ui:define name="header">#{messages['net.ihe.gazelle.simulators.MessageIdentifier']}</ui:define>
                        <h:outputText
                                value="#{log.messageIdentifier}"/>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['net.ihe.gazelle.simulators.AckCode']}</ui:define>
                        <h:outputText
                                value="#{log.code}"/>
                        <ui:decorate template="/layout/popover/_popover_on_icon.xhtml">
                            <ui:param name="id" value="pop#{log.id}"/>
                            <ui:param name="icon_class" value="gzl-icon-question-circle"/>
                            <ui:define name="content">
                                <h:outputText value="#{log.comment}"/>
                            </ui:define>
                        </ui:decorate>
                    </g:column>
                    <ui:define name="footer">
                        <ui:include src="/util/datatableFooter.xhtml">
                            <ui:param name="dataScrollerId" value="ds"/>
                            <ui:param name="dataTableId" value="messageList"/>
                        </ui:include>
                    </ui:define>
                </rich:dataTable>
            </ui:decorate>
        </h:form>
    </ui:define>
</ui:composition>
